/*
 * $Id: Parameters.cpp 109 2009-02-16 20:28:31Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/include/Parameters.h"

namespace morpheo {
namespace behavioural {
namespace core {
namespace multi_front_end {
namespace front_end {
namespace ifetch_unit {
namespace ifetch_queue {


#undef  FUNCTION
#define FUNCTION "Ifetch_queue::Parameters"
  Parameters::Parameters (uint32_t size_queue                   ,
			  uint32_t nb_instruction               ,
			  uint32_t size_branch_update_prediction,
			  uint32_t size_general_data            ,
                          bool     is_toplevel)
  {
    log_printf(FUNC,Ifetch_queue,FUNCTION,"Begin");

    _nb_instruction_in_queue               = size_queue                   ;
    _size_queue                            = size_queue/nb_instruction    ;
    _nb_instruction                        = nb_instruction               ;
//  _size_branch_update_prediction         = size_branch_update_prediction;
//  _size_general_data                     = size_general_data            ;

    test();

    if (is_toplevel)
      {
        _size_instruction_address   = size_general_data;
        _size_ifetch_queue_ptr      = log2(size_queue);
        _size_inst_ifetch_ptr       = log2(nb_instruction);
        _size_depth                 = size_branch_update_prediction;

        _have_port_ifetch_queue_ptr = _size_ifetch_queue_ptr > 0;
        _have_port_inst_ifetch_ptr  = _size_inst_ifetch_ptr > 0;
        _have_port_depth            = _size_depth > 0;

        copy ();
      }

    log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
  };
  
// #undef  FUNCTION
// #define FUNCTION "Ifetch_queue::Parameters (copy)"
//   Parameters::Parameters (Parameters & param)
//   {
//     log_printf(FUNC,Ifetch_queue,FUNCTION,"Begin");
//     test();
//     log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
//   };

#undef  FUNCTION
#define FUNCTION "Ifetch_queue::~Parameters"
  Parameters::~Parameters () 
  {
    log_printf(FUNC,Ifetch_queue,FUNCTION,"Begin");
    log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
  };

#undef  FUNCTION
#define FUNCTION "Ifetch_queue::copy"
  void Parameters::copy (void) 
  {
    log_printf(FUNC,Ifetch_queue,FUNCTION,"Begin");
    log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
  };

}; // end namespace ifetch_queue
}; // end namespace ifetch_unit
}; // end namespace front_end
}; // end namespace multi_front_end
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              
